local VERSION = tonumber(("$Revision: 54640 $"):match("%d+"))

local Spyglass = Spyglass

if Spyglass.revision < VERSION then
	Spyglass.version = "r" .. VERSION
	Spyglass.revision = VERSION
	Spyglass.date = ("$Date: 2007-11-14 05:47:09 -0500 (Wed, 14 Nov 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

Spyglass_FuBar = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0",
                                                "AceConsole-2.0",
                                                "FuBarPlugin-2.0")

local Spyglass_FuBar = Spyglass_FuBar

local L = AceLibrary("AceLocale-2.2"):new("Spyglass")

Spyglass_FuBar.name = 'Spyglass'
Spyglass_FuBar.version = Spyglass.version
Spyglass_FuBar.revision = Spyglass.revision
Spyglass_FuBar.date = Spyglass.date
Spyglass_FuBar.hasIcon = [[Interface\Icons\INV_Misc_Spyglass_03]]
Spyglass_FuBar.hasNoColor = true
Spyglass_FuBar.defaultMinimapPosition = 285
Spyglass_FuBar.clickableTooltip = true
Spyglass_FuBar.cannotDetachTooltip = true

function Spyglass_FuBar:OnInitialize()
    -- Method of attaching the fubar options borrowed from Bartender3
    self.db = Spyglass:AcquireDBNamespace('fubar')
    
    Spyglass.options.args.fubar_spacer = {
        order = 20,
        type = 'header',
    }
    
    Spyglass.options.args.fubar = {
        order = 21,
        type = 'group',
        name = L['Menu'],
        desc = L['Menu Options'],
        args = {},
    }
    
    AceLibrary('AceConsole-2.0'):InjectAceOptionsTable(self, Spyglass.options.args.fubar)
    self.OnMenuRequest = Spyglass.options
end

function Spyglass_FuBar:OnEnable()
    self:Update()
end

local Tablet = AceLibrary("Tablet-2.0")
function Spyglass_FuBar:OnTooltipUpdate()
    if Spyglass:IsActive() then
        local cat = Tablet:AddCategory(
            'columns', 2,
            'text', L['Last Inspected Unit']
        )
        
        cat:AddLine(
            'text2', Spyglass.db.profile.lastInspected or L['nobody'],
            'func', 'SetInspectPlayer',
            'arg1', self,
            'arg2', Spyglass.db.profile.lastInspected
        )
        
        cat = Tablet:AddCategory(
            'columns', 2,
            'text', L['Saved Units']
        )
        
        for i, name in ipairs(Spyglass:GetCachedPlayerNames()) do
            local info = Spyglass:GetUnitInfo(name)
            cat:AddLine('text', name, 'text2', info.level..' '..info.class,
                        'func', 'SetInspectPlayer',
                        'arg1', self,
                        'arg2', name)
        end
        
        Tablet:SetHint(L["|cffeda55fClick|r to toggle the inspect window."])
    else
        Tablet:SetHint(L["|cffeda55fDisabled|r"])
    end
end

function Spyglass_FuBar:SetInspectPlayer(name)
    if IsControlKeyDown() then
        Spyglass:RemoveUnitInfo(name)
        self:UpdateTooltip()
    else
        Spyglass:SetInspectPlayer(name)
    end
end

function Spyglass_FuBar:OnClick(button)
    Spyglass:ShowWindow()
end

